package org.apache.xindice.client.corba.db;

//
// Helper class for : APIException
//
// @author OpenORB Compiler
//
public class APIExceptionHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert APIException into an any
	// @param	a an any
	// @param	t APIException value
	//
	public static void insert( org.omg.CORBA.Any a, org.apache.xindice.client.corba.db.APIException t )
	{
		a.insert_Streamable( new org.apache.xindice.client.corba.db.APIExceptionHolder( t ));
	}

	//
	// Extract APIException from an any
	// @param	a an any
	// @return the extracted APIException value
	//
	public static org.apache.xindice.client.corba.db.APIException extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.apache.xindice.client.corba.db.APIExceptionHolder)
					return ((org.apache.xindice.client.corba.db.APIExceptionHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.apache.xindice.client.corba.db.APIExceptionHolder h = new org.apache.xindice.client.corba.db.APIExceptionHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the APIException TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "faultCode";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "faultMessage";
				_members[1].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "exceptionMessage";
				_members[2].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_tc = orb.create_exception_tc(id(),"APIException",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the APIException IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:org/apache/xindice/client/corba/db/APIException:1.0";

	//
	// Read APIException from a marshalled stream
	// @param	istream the input stream
	// @return the readed APIException value
	//
	public static org.apache.xindice.client.corba.db.APIException read( org.omg.CORBA.portable.InputStream istream )
	{
		org.apache.xindice.client.corba.db.APIException new_one = new org.apache.xindice.client.corba.db.APIException();

		if ( !istream.read_string().equals( id() ) )
			throw new org.omg.CORBA.MARSHAL();
		new_one.faultCode = istream.read_long();
		new_one.faultMessage = istream.read_string();
		new_one.exceptionMessage = istream.read_string();

		return new_one;
	}

	//
	// Write APIException into a marshalled stream
	// @param	ostream the output stream
	// @param	value APIException value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.apache.xindice.client.corba.db.APIException value )
	{
		ostream.write_string( id() );
		ostream.write_long(value.faultCode);
		ostream.write_string(value.faultMessage);
		ostream.write_string(value.exceptionMessage);
	}

}
