package org.apache.xindice.client.corba.db;

//
// Interface definition : Collection
//
// @author OpenORB Compiler
//
public abstract class CollectionPOA extends org.omg.PortableServer.Servant
		implements CollectionOperations, org.omg.CORBA.portable.InvokeHandler
{
	public Collection _this()
	{
		return CollectionHelper.narrow(_this_object());
	}

	public Collection _this( org.omg.CORBA.ORB orb )
	{
		return CollectionHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:org/apache/xindice/client/corba/db/Collection:1.0", 
		"IDL:org/apache/xindice/client/corba/db/ServantManagement:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	private static java.util.Hashtable _ops_Hash = new java.util.Hashtable();
	static {
		_ops_Hash.put("getName", new Integer(0) );
		_ops_Hash.put("getCanonicalName", new Integer(4) );
		_ops_Hash.put("getCollectionManager", new Integer(8) );
		_ops_Hash.put("getParentCollection", new Integer(12) );
		_ops_Hash.put("listCollections", new Integer(16) );
		_ops_Hash.put("getCollection", new Integer(20) );
		_ops_Hash.put("insertDocument", new Integer(24) );
		_ops_Hash.put("removeDocument", new Integer(28) );
		_ops_Hash.put("getDocument", new Integer(32) );
		_ops_Hash.put("setDocument", new Integer(36) );
		_ops_Hash.put("getDocuments", new Integer(40) );
		_ops_Hash.put("listDocuments", new Integer(44) );
		_ops_Hash.put("getDocumentCount", new Integer(48) );
		_ops_Hash.put("createNewOID", new Integer(52) );
		_ops_Hash.put("queryCollection", new Integer(56) );
		_ops_Hash.put("queryDocument", new Integer(60) );
		_ops_Hash.put("invokeXMLObject", new Integer(64) );
		_ops_Hash.put("remove", new Integer(68) );
	};

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		Integer opidx = (Integer)_ops_Hash.get(opName);
		if(opidx == null)
			throw new org.omg.CORBA.BAD_OPERATION();

		switch(opidx.intValue()) {
		case 0:
		{

			try
			{
				String _arg_result = getName();

				_output = handler.createReply();
				_output.write_string(_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 4:
		{

			try
			{
				String _arg_result = getCanonicalName();

				_output = handler.createReply();
				_output.write_string(_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 8:
		{

			try
			{
				org.apache.xindice.client.corba.db.CollectionManager _arg_result = getCollectionManager();

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.CollectionManagerHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 12:
		{

			try
			{
				org.apache.xindice.client.corba.db.Collection _arg_result = getParentCollection();

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.CollectionHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 16:
		{

			try
			{
				String[] _arg_result = listCollections();

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.NamesHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 20:
		{
			String arg0_in = org.apache.xindice.client.corba.db.NameHelper.read(_is);

			try
			{
				org.apache.xindice.client.corba.db.Collection _arg_result = getCollection(arg0_in);

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.CollectionHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 24:
		{
			String arg0_in = org.apache.xindice.client.corba.db.NameHelper.read(_is);
			org.apache.xindice.client.corba.db.EncodedBuffer arg1_in = org.apache.xindice.client.corba.db.EncodedBufferHelper.read(_is);

			try
			{
				String _arg_result = insertDocument(arg0_in, arg1_in);

				_output = handler.createReply();
				_output.write_string(_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 28:
		{
			String arg0_in = _is.read_string();

			try
			{
				removeDocument(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 32:
		{
			String arg0_in = _is.read_string();
			long arg1_in = org.apache.xindice.client.corba.db.TimestampHelper.read(_is);

			try
			{
				org.apache.xindice.client.corba.db.EncodedBuffer _arg_result = getDocument(arg0_in, arg1_in);

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.EncodedBufferHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 36:
		{
			String arg0_in = _is.read_string();
			org.apache.xindice.client.corba.db.EncodedBuffer arg1_in = org.apache.xindice.client.corba.db.EncodedBufferHelper.read(_is);

			try
			{
				setDocument(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 40:
		{

			try
			{
				org.apache.xindice.client.corba.db.DocumentSet _arg_result = getDocuments();

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.DocumentSetHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 44:
		{

			try
			{
				String[] _arg_result = listDocuments();

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.NamesHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 48:
		{

			try
			{
				int _arg_result = getDocumentCount();

				_output = handler.createReply();
				_output.write_long(_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 52:
		{

			try
			{
				String _arg_result = createNewOID();

				_output = handler.createReply();
				_output.write_string(_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 56:
		{
			String arg0_in = _is.read_string();
			String arg1_in = org.apache.xindice.client.corba.db.ValueHelper.read(_is);
			org.apache.xindice.client.corba.db.NamedVal[] arg2_in = org.apache.xindice.client.corba.db.NamedValsHelper.read(_is);
			long arg3_in = org.apache.xindice.client.corba.db.TimestampHelper.read(_is);

			try
			{
				org.apache.xindice.client.corba.db.EncodedBuffer _arg_result = queryCollection(arg0_in, arg1_in, arg2_in, arg3_in);

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.EncodedBufferHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 60:
		{
			String arg0_in = _is.read_string();
			String arg1_in = org.apache.xindice.client.corba.db.ValueHelper.read(_is);
			org.apache.xindice.client.corba.db.NamedVal[] arg2_in = org.apache.xindice.client.corba.db.NamedValsHelper.read(_is);
			String arg3_in = _is.read_string();
			long arg4_in = org.apache.xindice.client.corba.db.TimestampHelper.read(_is);

			try
			{
				org.apache.xindice.client.corba.db.EncodedBuffer _arg_result = queryDocument(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.EncodedBufferHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 64:
		{
			String arg0_in = _is.read_string();

			try
			{
				org.apache.xindice.client.corba.db.EncodedBuffer _arg_result = invokeXMLObject(arg0_in);

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.EncodedBufferHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		case 68:
		{

			remove();

			_output = handler.createReply();

			return _output;
		}
		}

		// never reached
		throw new org.omg.CORBA.INTERNAL();
	}
}
